# Generated by Django 5.0.3 on 2024-06-14 13:27

import django.contrib.postgres.fields
import django.db.models.deletion
from django.db import migrations, models


class Migration(migrations.Migration):

    dependencies = [
        ('intent', '0003_alter_expectationobject_object_instance'),
    ]

    operations = [
        migrations.CreateModel(
            name='FulfilmentInfo',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('fulfilment_status', models.CharField(choices=[('FULFILLED', 'FULFILLED'), ('NOT_FULFILLED', 'NOT_FULFILLED')], db_index=True, default='NOT_FULFILLED', max_length=20)),
                ('not_fulfilled_state', models.CharField(choices=[('ACKNOWLEDGED', 'ACKNOWLEDGED'), ('COMPLIANT', 'COMPLIANT'), ('DEGRADED', 'DEGRADED'), ('SUSPENDED', 'SUSPENDED'), ('TERMINATED', 'TERMINATED'), ('FULFILMENTFAILED', 'FULFILMENTFAILED')], db_index=True, default='ACKNOWLEDGED', max_length=20)),
                ('not_fulfilled_reasons', django.contrib.postgres.fields.ArrayField(base_field=models.TextField(blank=True, null=True), default=list, size=None)),
            ],
            options={
                'verbose_name': 'Fulfilment Info',
                'verbose_name_plural': 'Fulfilments Info',
                'db_table': 'fulfilment_info',
            },
        ),
        migrations.CreateModel(
            name='IntentFeasibilityReport',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('feasibility_check_type', models.CharField(choices=[('FEASIBLE', 'FEASIBLE'), ('INFEASIBLE', 'INFEASIBLE')], db_index=True, max_length=10)),
                ('infeasibility_reason', models.TextField(blank=True, help_text='An attribute which is used when feasibilityCheckResult is INFEASIBLE', null=True)),
            ],
            options={
                'verbose_name': 'Intent Feasibility Report',
                'verbose_name_plural': 'Intent Feasibility Reports',
                'db_table': 'intent_feasibility_report',
            },
        ),
        migrations.CreateModel(
            name='IntentFulfilmentReport',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('intent_fulfilment_info', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='intent_fulfilment_reports', to='intent.fulfilmentinfo')),
            ],
            options={
                'verbose_name': 'Intent Fulfilment Report',
                'verbose_name_plural': 'Intent Fulfilment Reports',
                'db_table': 'intent_fulfilment_report',
            },
        ),
        migrations.CreateModel(
            name='ExpectationFulfilmentResult',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('expectation', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='expectation_fulfilment_results', to='intent.intentexpectation')),
                ('expectation_fulfilment_info', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='expectation_fulfilment_results', to='intent.fulfilmentinfo')),
                ('intent_fulfilment_report', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='intent_fulfilment_results', to='intent.intentfulfilmentreport')),
            ],
            options={
                'verbose_name': 'Expectation Fulfilment Result',
                'verbose_name_plural': 'Expectation Fulfilment Results',
                'db_table': 'expectation_fulfilment_result',
            },
        ),
        migrations.CreateModel(
            name='IntentReport',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('last_updated_time', models.DateTimeField(auto_now=True)),
                ('intent_feasibility_check_report', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='intent_reports', to='intent.intentfeasibilityreport')),
                ('intent_fulfilment_report', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='intent_reports', to='intent.intentfulfilmentreport')),
                ('intent_reference', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='intent_reports', to='intent.intent')),
            ],
            options={
                'verbose_name': 'Intent Report',
                'verbose_name_plural': 'Intent Reports',
                'db_table': 'intent_port',
            },
        ),
        migrations.CreateModel(
            name='IntentConflictReport',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('conflict_type', models.CharField(choices=[('INTENT_CONFLICT', 'INTENT_CONFLICT'), ('EXPECTATION_CONFLICT', 'EXPECTATION_CONFLICT'), ('TARGET_CONFLICT', 'TARGET_CONFLICT')], db_index=True, max_length=30)),
                ('recommended_solutions', models.CharField(blank=True, choices=[('MODIFY', 'MODIFY'), ('DELETE', 'DELETE')], max_length=30, null=True)),
                ('conflicting_expectation', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='conflicting_expectation_reports', to='intent.intentexpectation')),
                ('conflicting_intent', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='conflicting_intent_reports', to='intent.intent')),
                ('conflicting_target', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='conflicting_target_reports', to='intent.expectationtarget')),
                ('intent_report', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='intent_conflict_reports', to='intent.intentreport')),
            ],
            options={
                'verbose_name': 'Intent Conflict Report',
                'verbose_name_plural': 'Intent Conflict Reports',
                'db_table': 'intent_conflict_report',
            },
        ),
        migrations.CreateModel(
            name='TargetFulfilmentResult',
            fields=[
                ('id', models.BigAutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('target_achieved_value', models.CharField(blank=True, max_length=256, null=True)),
                ('expectation_fulfilment_result', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='target_fulfilment_results', to='intent.expectationfulfilmentresult')),
                ('target', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='target_fulfilment_results', to='intent.expectationtarget')),
                ('target_fulfilment_info', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='target_fulfilment_results', to='intent.fulfilmentinfo')),
            ],
            options={
                'verbose_name': 'Target Fulfilment Result',
                'verbose_name_plural': 'Target Fulfilment Results',
                'db_table': 'target_fulfilment_result',
            },
        ),
    ]
